<?php

namespace Licenzo\Framework\Database\Eloquent\Casts;

use Licenzo\Framework\Contracts\Database\Eloquent\Castable;
use Licenzo\Framework\Contracts\Database\Eloquent\CastsAttributes;
use Licenzo\Framework\Support\Str;

class AsStringable implements Castable
{
    /**
     * Get the caster class to use when casting from / to this cast target.
     *
     * @param  array  $arguments
     * @return \Licenzo\Framework\Contracts\Database\Eloquent\CastsAttributes<\Licenzo\Framework\Support\Stringable, string|\Stringable>
     */
    public static function castUsing(array $arguments)
    {
        return new class implements CastsAttributes
        {
            public function get($model, $key, $value, $attributes)
            {
                return isset($value) ? Str::of($value) : null;
            }

            public function set($model, $key, $value, $attributes)
            {
                return isset($value) ? (string) $value : null;
            }
        };
    }
}
